#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include "iolib.h"
const char *progname = "envuidgid";
#include "freedt.h"

int main(int argc, char **argv) {
	struct passwd *p;
	buffer b = BUFFER;

	istdinit();

	if (argc < 3)
		die("usage: envuidgid account command ...");

	p = getpwnam(argv[1]);
	if (!p)
		die2(argv[1], "no such account");
	bformat(&b, 'i', p->pw_uid, 0);
	if (fdt_setenv("UID", bstr(&b)) < 0)
		die("unable to set UID");
	bfree(&b);
	bformat(&b, 'i', p->pw_gid, 0);
	if (fdt_setenv("GID", bstr(&b)) < 0)
		die("unable to set GID");
	bfree(&b);

	execvp(argv[2], &argv[2]);
	die2(argv[2], "unable to exec");

	return 0; /* NOTREACHED */
}

